Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 313425)
+++ channels/chan_sip.c	(working copy)
@@ -6070,7 +6080,9 @@
 			return 0;
 		}
 		if (p) {
-			sip_pvt_lock(p);
+			while (sip_pvt_trylock(p)) {
+				CHANNEL_DEADLOCK_AVOIDANCE(ast);
+			}
 			if (p->rtp) {
 				/* If channel is not up, activate early media session */
 				if ((ast->_state != AST_STATE_UP) &&
@@ -27688,7 +27717,10 @@
 		return AST_RTP_GLUE_RESULT_FORBID;
 	}
 
-	sip_pvt_lock(p);
+	while (sip_pvt_trylock(p)) {
+		CHANNEL_DEADLOCK_AVOIDANCE(chan);
+	}
+
 	if (!(p->rtp)) {
 		sip_pvt_unlock(p);
 		return AST_RTP_GLUE_RESULT_FORBID;
